package lcsb.mapviewer.api.mirna;

import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import lcsb.mapviewer.api.BaseController;
import lcsb.mapviewer.api.QueryException;
import lcsb.mapviewer.services.SecurityException;

@RestController
@RequestMapping("/miRna")
public class MiRnaController extends BaseController {

	@Autowired
	private MiRnaRestImpl miRnaController;

	@RequestMapping(value = "/getMiRnasByQuery", method = { RequestMethod.GET, RequestMethod.POST }, produces = { MediaType.APPLICATION_JSON_VALUE })
	public List<Map<String, Object>> getMiRnasByQuery(@RequestParam(value = "token") String token, @RequestParam(value = "projectId") String projectId,
			@RequestParam(value = "columns", defaultValue = "") String columns, @RequestParam(value = "query") String query)
			throws SecurityException, QueryException {
		return miRnaController.getMiRnasByQuery(token, projectId, columns, query);
	}

	@RequestMapping(value = "/getMiRnasByTarget", method = { RequestMethod.GET, RequestMethod.POST }, produces = { MediaType.APPLICATION_JSON_VALUE })
	public List<Map<String, Object>> getMiRnasByTarget(@RequestParam(value = "token") String token, @RequestParam(value = "projectId") String projectId,
			@RequestParam(value = "targetType", defaultValue = "ALIAS") String targetType, @RequestParam(value = "targetId", defaultValue = "") String targetId,
			@RequestParam(value = "columns", defaultValue = "") String columns) throws SecurityException, QueryException {
		return miRnaController.getMiRnasByTarget(token, projectId, targetType, targetId, columns);
	}

}